#include <stdio.h>
#include <libgen.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>

static void
translate(FILE *in, FILE *out)
{
	assert(0);
}

int
copy_by_hand(char *from, char *to)
{
	assert(0);
	return -1;
}

int
main(int argc, char *argv[])
{
	FILE *in, *out;
	char *us = basename(argv[0]), *tmpname = mktemp(us);
	switch(argc)
	{
		case 1:
			in = stdin;
			out = stdout;
			break;
		case 2:
			in = fopen(argv[1], "rb");
			out = fopen(tmpname, "wb");
			break;
		case 3:
			in = fopen(argv[1], "rb");
			out = fopen(tmpname, "wb");
			break;
		default:
			printf("Usage: %s [infile] [outfile]\n"
				"If neither infile nor outfile are given, stdin and stdout will be used.\n"
				"If only infile is given, file will be translated inplace.\n", us);
			return -1;
	}
	if(!out)
	{
		perror("fopen");
		fclose(in);
		return -1;
	}
	if(!in)
	{
		perror("fopen");
		return -1;
	}
	translate(in, out);
	if(argc > 1)
	{
		fclose(in);
		fclose(out);
		if(argc < 3)
		{
			if(rename(tmpname, argv[1]))
			{
				int err = errno;
				perror("rename");
				if(err == EXDEV)
				{
					fprintf(stderr, "It seems that files %s and %s reside on different FSs\n",
						tmpname, argv[1]);
					copy_by_hand(tmpname, argv[1]);
				}
			}
			unlink(tmpname);
		}
	}
	return 0;
}
